﻿module MainForm

open System
open System.Drawing 
open System.Windows.Forms
open SiteInfo
open Resoures
open WebTools
open ErrorsForm
open SearchTools

open System.IO
open System.Xml
open System.Xml.Serialization
open System.Xml.Linq 
open System.Xml.XPath 
open System.Runtime.Serialization
open System.Text.RegularExpressions
open System.Collections.Generic
open System.Threading 
  
let DelegateAddNodeToTreeViewMethod(treeView: System.Windows.Forms.TreeView, key: string, value: string) =
    treeView.Nodes.Add(key, value)
let DelegateAddNodeToNodeMethod(treeNode: System.Windows.Forms.TreeNode, key: string, value: string) =
    treeNode.Nodes.Add(key, value)  
    
type MainForm() as this = 
    inherit Form() 

    let mutable components: System.ComponentModel.Container = null
    let mutable tabControl: System.Windows.Forms.TabControl = null
    let mutable tabPgBrowse: System.Windows.Forms.TabPage = null
    let mutable splitContainer: System.Windows.Forms.SplitContainer = null
    let mutable treeView: System.Windows.Forms.TreeView = null
    let mutable webBrowser: System.Windows.Forms.WebBrowser = null
    let mutable tabPgOptions: System.Windows.Forms.TabPage = null
    let mutable menuStrip: System.Windows.Forms.MenuStrip = null
    let mutable fileToolStripMenuItem: System.Windows.Forms.ToolStripMenuItem = null
    let mutable exitToolStripMenuItem: System.Windows.Forms.ToolStripMenuItem = null
    let mutable windowToolStripMenuItem: System.Windows.Forms.ToolStripMenuItem = null
    let mutable aboutToolStripMenuItem: System.Windows.Forms.ToolStripMenuItem = null
    let mutable openToolStripMenuItem: System.Windows.Forms.ToolStripMenuItem = null
    let mutable downloadAllToolStripMenuItem: System.Windows.Forms.ToolStripMenuItem = null
    let mutable relplaceAllLinksToolStripMenuItem: System.Windows.Forms.ToolStripMenuItem = null
    let mutable terminateOperationToolStripMenuItem: System.Windows.Forms.ToolStripMenuItem = null
    let mutable refreshTOCToolStripMenuItem: System.Windows.Forms.ToolStripMenuItem = null
    let mutable updateNodeToolStripMenuItem: System.Windows.Forms.ToolStripMenuItem = null
    let mutable toolStripSeparator1: System.Windows.Forms.ToolStripSeparator = null
    let mutable toolStripSeparator2: System.Windows.Forms.ToolStripSeparator = null
    let mutable btnSelect: System.Windows.Forms.Button = null
    let mutable txtFolder: System.Windows.Forms.TextBox = null
    let mutable lblFolder: System.Windows.Forms.Label = null
    let mutable txtUrl: System.Windows.Forms.TextBox = null
    let mutable lblUrl: System.Windows.Forms.Label = null
    let mutable folderBrowserDialog: System.Windows.Forms.FolderBrowserDialog = null
    let mutable btnBrowse: System.Windows.Forms.Button = null
    let mutable cobLang: System.Windows.Forms.ComboBox = null
    let mutable lblLang: System.Windows.Forms.Label = null
    let mutable btnSyncWithTOC: System.Windows.Forms.Button = null
    let mutable btnGoForward: System.Windows.Forms.Button = null
    let mutable btnGoBack: System.Windows.Forms.Button = null
    let mutable btnFind: System.Windows.Forms.Button = null
    let mutable txtQuery: System.Windows.Forms.TextBox = null
    (* let mutable txtLimitChildItems: System.Windows.Forms.TextBox  = null
    let mutable lblLimitChildItems: System.Windows.Forms.Label = null *)
    let mutable txtDepthTocLevel: System.Windows.Forms.TextBox = null
    let mutable lblDepthTocLevel: System.Windows.Forms.Label = null
    let mutable chkAutoReplaceUrls: System.Windows.Forms.CheckBox = null;
    let mutable statusStrip: System.Windows.Forms.StatusStrip = null
    let mutable toolStripStatusLabel: System.Windows.Forms.ToolStripStatusLabel = null
    let mutable toolStripProgressBar: System.Windows.Forms.ToolStripProgressBar = null
    let mutable frmTimer: System.Windows.Forms.Timer = null
    let mutable cancelltionSource: System.Threading.CancellationTokenSource = null
    let mutable currentFolder: string = null
    let mutable currentUrl: string = null
    let mutable currentLang: string = null
    let mutable lastXmlFiles: int = 0
    let mutable hsFilesInFolder: HashSet<string> = null 
    let mutable hsFilesInSubfolder: HashSet<string> = null 

    [<DefaultValue>] val mutable public statusStripValues: StatusStripValues
    [<DefaultValue>] val mutable public runningOperation: Operation
    [<DefaultValue>] val mutable public nextOperation: Operation
    [<DefaultValue>] val mutable public additionalLinks: XElement

    do this.InitializeComponent(); 
        if (cobLang.SelectedIndex = (-1) && cobLang.Items.Count > 0) then 
            cobLang.SelectedIndex <- 0

    override this.Dispose(disposing) =
        if (disposing && (match components with null -> false | _ -> true)) then
          components.Dispose();
        base.Dispose(disposing)

    member private this.InitializeComponent() =
        components <- new System.ComponentModel.Container();
        let resources = new System.ComponentModel.ComponentResourceManager(typeof<MainForm>)
        splitContainer <- new System.Windows.Forms.SplitContainer();
        treeView <- new System.Windows.Forms.TreeView();
        webBrowser <- new System.Windows.Forms.WebBrowser();
        tabControl <- new System.Windows.Forms.TabControl();
        tabPgBrowse <- new System.Windows.Forms.TabPage();
        tabPgOptions <- new System.Windows.Forms.TabPage();
        menuStrip <- new System.Windows.Forms.MenuStrip();
        fileToolStripMenuItem <- new System.Windows.Forms.ToolStripMenuItem();
        exitToolStripMenuItem <- new System.Windows.Forms.ToolStripMenuItem();
        windowToolStripMenuItem <- new System.Windows.Forms.ToolStripMenuItem();
        aboutToolStripMenuItem <- new System.Windows.Forms.ToolStripMenuItem();
        openToolStripMenuItem <- new System.Windows.Forms.ToolStripMenuItem();
        downloadAllToolStripMenuItem <- new System.Windows.Forms.ToolStripMenuItem();
        terminateOperationToolStripMenuItem <- new System.Windows.Forms.ToolStripMenuItem();
        relplaceAllLinksToolStripMenuItem <- new System.Windows.Forms.ToolStripMenuItem();
        refreshTOCToolStripMenuItem <- new System.Windows.Forms.ToolStripMenuItem();
        updateNodeToolStripMenuItem <- new System.Windows.Forms.ToolStripMenuItem();
        toolStripSeparator1 <- new System.Windows.Forms.ToolStripSeparator();
        toolStripSeparator2 <- new System.Windows.Forms.ToolStripSeparator();
        btnBrowse <- new System.Windows.Forms.Button();
        btnSelect <- new System.Windows.Forms.Button();
        txtFolder <- new System.Windows.Forms.TextBox();
        lblFolder <- new System.Windows.Forms.Label();
        txtUrl <- new System.Windows.Forms.TextBox();
        lblUrl <- new System.Windows.Forms.Label();
        folderBrowserDialog <- new System.Windows.Forms.FolderBrowserDialog();
        cobLang <- new System.Windows.Forms.ComboBox();
        lblLang <- new System.Windows.Forms.Label();
        btnSyncWithTOC <- new System.Windows.Forms.Button();
        btnGoForward <- new System.Windows.Forms.Button();
        btnGoBack <- new System.Windows.Forms.Button();
        btnFind <- new System.Windows.Forms.Button();
        txtQuery <- new System.Windows.Forms.TextBox();
        (* txtLimitChildItems <- new System.Windows.Forms.TextBox();
        lblLimitChildItems <- new System.Windows.Forms.Label(); *)
        txtDepthTocLevel <- new System.Windows.Forms.TextBox();
        lblDepthTocLevel <- new System.Windows.Forms.Label();
        chkAutoReplaceUrls <- new System.Windows.Forms.CheckBox();
        statusStrip <- new System.Windows.Forms.StatusStrip();
        toolStripStatusLabel <- new System.Windows.Forms.ToolStripStatusLabel();
        toolStripProgressBar <- new System.Windows.Forms.ToolStripProgressBar();
        frmTimer <- new System.Windows.Forms.Timer();
        this.statusStripValues <- new StatusStripValues();
        this.runningOperation <- Operation.None;
        this.nextOperation <- Operation.None;
        this.additionalLinks <- new XElement(xname "root");
        hsFilesInFolder <- new HashSet<string>();
        hsFilesInSubfolder <- new HashSet<string>();

        (splitContainer :> System.ComponentModel.ISupportInitialize).BeginInit(); 
        //((System.ComponentModel.ISupportInitialize)(splitContainer)).BeginInit();
        splitContainer.Panel1.SuspendLayout();
        splitContainer.Panel2.SuspendLayout();
        splitContainer.SuspendLayout();
        tabControl.SuspendLayout();
        tabPgBrowse.SuspendLayout();
        menuStrip.SuspendLayout();
        statusStrip.SuspendLayout();
        this.SuspendLayout();
        // 
        // splitContainer
        // 
        resources.ApplyResources(splitContainer, "splitContainer");
        splitContainer.Name <- "splitContainer";
        // 
        // splitContainer.Panel1
        // 
        splitContainer.Panel1.Controls.Add(btnFind);
        splitContainer.Panel1.Controls.Add(txtQuery);
        splitContainer.Panel1.Controls.Add(treeView);
        // 
        // splitContainer.Panel2
        // 
        splitContainer.Panel2.Controls.Add(btnSyncWithTOC);
        splitContainer.Panel2.Controls.Add(btnGoForward);
        splitContainer.Panel2.Controls.Add(btnGoBack);
        splitContainer.Panel2.Controls.Add(webBrowser);
        // 
        // btnSyncWithTOC
        // 
        resources.ApplyResources(btnSyncWithTOC, "btnSyncWithTOC");
        btnSyncWithTOC.Name <- "btnSyncWithTOC";
        btnSyncWithTOC.UseVisualStyleBackColor <- true;
        btnSyncWithTOC.Click.AddHandler (fun s e -> 
            if (webBrowser.Document <> null) then
                let url = Regex.Replace(webBrowser.DocumentText |> GetUrlForHtmlDoc, CommonDefs.RegExprAspExt, String.Empty)
                if (not <| String.IsNullOrEmpty(url)) then
                    let foudNodes = treeView.Nodes.Find(url, true)
                    if (foudNodes <> null && foudNodes.Length > 0) then
                        treeView.SelectedNode <- foudNodes.[0]
                    else 
                        let canonicalUrl = Regex.Replace(GetCanonicalUrlForHtmlDoc(webBrowser.DocumentText), CommonDefs.RegExprAspExt, String.Empty)
                        if (not <| String.IsNullOrEmpty(canonicalUrl)) then 
                            let foudNodes = treeView.Nodes.Find(canonicalUrl, true)
                            if (foudNodes <> null && foudNodes.Length > 0) then
                                treeView.SelectedNode <- foudNodes.[0]);
        // 
        // btnGoForward
        // 
        resources.ApplyResources(btnGoForward, "btnGoForward");
        btnGoForward.Name <- "btnGoForward";
        btnGoForward.UseVisualStyleBackColor <- true;
        btnGoForward.Click.AddHandler (fun s e -> ignore(webBrowser.GoForward())); 
        // 
        // btnGoBack
        // 
        resources.ApplyResources(btnGoBack, "btnGoBack");
        btnGoBack.Name <- "btnGoBack";
        btnGoBack.UseVisualStyleBackColor <- true;
        btnGoBack.Click.AddHandler (fun s e -> ignore(webBrowser.GoBack())); 
        // 
        // treeView
        // 
        resources.ApplyResources(treeView, "treeView");
        treeView.Name <- "treeView";
        treeView.HideSelection <- false;
        treeView.AfterSelect.AddHandler(fun s e ->
            let node: TreeNode = e.Node
            let href: string = node.Tag :?> string
            let isAdditionally = node.FullPath.Contains(ModuleResoures.GetAppResourceString("Additionally"))
            let nodeLevel = node.Level  
            if (href <> CommonDefs.RootItemRefAdditionally) then
                let lfHtm = GetLocalFile(txtFolder.Text, href, CommonDefs.HtmlExt)
                let cs = new System.Threading.CancellationTokenSource()  
                if (File.Exists(lfHtm)) then
                    if (node.Nodes.Count = 0) then
                        Application.UseWaitCursor <- true
                        Application.DoEvents()  
                        AddChildNodes(
                            null, 
                            cs.Token, 
                            treeView,
                            node,
                            this.additionalLinks,  
                            txtFolder.Text, 
                            (if (String.IsNullOrEmpty(txtDepthTocLevel.Text)) then 0(*CommonDefs.MaxDepthTocLevel*) else System.Int32.Parse(txtDepthTocLevel.Text) + nodeLevel), 
                            0(*(if (String.IsNullOrEmpty(txtLimitChildItems.Text)) then 0 else System.Int32.Parse(txtLimitChildItems.Text))*), 
                            nodeLevel, 
                            lfHtm)
                    webBrowser.Navigate(lfHtm)
                    Application.UseWaitCursor <- false
                else
                    if (not(isAdditionally) || not((node.Parent.Tag :?> string).Contains(CommonDefs.RootItemRefAdditionally))) then 
                        Application.UseWaitCursor <- true
                        Application.DoEvents()  
                        try
                            let (lfHtm, lstErr) = GetDataToView(
                                                    this.additionalLinks, 
                                                    txtFolder.Text,
                                                    href, 
                                                    cobLang.SelectedItem :?> string,
                                                    chkAutoReplaceUrls.Checked,
                                                    hsFilesInFolder,
                                                    hsFilesInSubfolder)
                            let hrefFileName = Path.GetFileNameWithoutExtension(href) 
                            let localFileName = Path.GetFileNameWithoutExtension(lfHtm)
                            if (hrefFileName <> localFileName) then
                                node.Tag <- Regex.Replace(href, hrefFileName, localFileName)
                            if (File.Exists(lfHtm)) then
                                AddChildNodes(
                                    null, 
                                    cs.Token, 
                                    treeView,
                                    node,
                                    this.additionalLinks, 
                                    txtFolder.Text, 
                                    (if (String.IsNullOrEmpty(txtDepthTocLevel.Text)) then 0 else System.Int32.Parse(txtDepthTocLevel.Text) + nodeLevel), 
                                    0(*(if (String.IsNullOrEmpty(txtLimitChildItems.Text)) then 0 else System.Int32.Parse(txtLimitChildItems.Text))*), 
                                    nodeLevel, 
                                    lfHtm)
                                webBrowser.Navigate(lfHtm)
                                if (lstErr.Length > 0) then
                                    this.ShowListErrors(lstErr)
                        with
                            | _ as ex -> Application.UseWaitCursor <- false; 
                                            ignore(MessageBox.Show(
                                                            this, 
                                                            ex.ToString(), 
                                                            Resoures.ModuleResoures.GetAppResourceString("CaptionError"), 
                                                            MessageBoxButtons.OK, 
                                                            MessageBoxIcon.Error)) 
                        Application.UseWaitCursor <- false
            );  
        // 
        // webBrowser
        // 
        resources.ApplyResources(webBrowser, "webBrowser");
        webBrowser.MinimumSize <- new System.Drawing.Size(20, 20);
        webBrowser.Name <- "webBrowser";
        // 
        // tabControl
        // 
        resources.ApplyResources(tabControl, "tabControl");
        tabControl.Controls.Add(tabPgBrowse);
        tabControl.Controls.Add(tabPgOptions);
        tabControl.Name <- "tabControl";
        tabControl.SelectedIndex <- 0;
        //tabControl.SelectedIndexChanged.AddHandler(fun s e -> if (tabControl.SelectedIndex = 0) then
        //    RefreshView(txtFolder.Text, txtUrl.Text));  

        // 
        // tabPgBrowse
        // 
        tabPgBrowse.Controls.Add(splitContainer);
        resources.ApplyResources(tabPgBrowse, "tabPgBrowse");
        tabPgBrowse.Name <- "tabPgBrowse";
        tabPgBrowse.UseVisualStyleBackColor <- true;
        // 
        // tabPgOptions
        // 
        resources.ApplyResources(tabPgOptions, "tabPgOptions");
        tabPgOptions.Controls.Add(btnBrowse);
        tabPgOptions.Controls.Add(btnSelect);
        tabPgOptions.Controls.Add(txtFolder);
        tabPgOptions.Controls.Add(lblFolder);
        tabPgOptions.Controls.Add(txtUrl);
        tabPgOptions.Controls.Add(lblUrl);
        tabPgOptions.Controls.Add(lblLang);
        tabPgOptions.Controls.Add(cobLang);
        (*tabPgOptions.Controls.Add(txtLimitChildItems);
        tabPgOptions.Controls.Add(lblLimitChildItems);*)
        tabPgOptions.Controls.Add(txtDepthTocLevel);
        tabPgOptions.Controls.Add(lblDepthTocLevel);
        tabPgOptions.Controls.Add(chkAutoReplaceUrls);
        tabPgOptions.Name <- "tabPgOptions";
        tabPgOptions.UseVisualStyleBackColor <- true;
        // 
        // cobLang
        // 
        resources.ApplyResources(cobLang, "cobLang");
        cobLang.DropDownStyle <- System.Windows.Forms.ComboBoxStyle.DropDownList;
        cobLang.FormattingEnabled <- true;
        ignore(cobLang.Items.Add(resources.GetString("cobLang.Items"))); 
        ignore(cobLang.Items.Add(resources.GetString("cobLang.Items1"))); 
        ignore(cobLang.Items.Add(resources.GetString("cobLang.Items2"))); 
        ignore(cobLang.Items.Add(resources.GetString("cobLang.Items3"))); 
        ignore(cobLang.Items.Add(resources.GetString("cobLang.Items4"))); 
        cobLang.Name <- "cobLang";
        // 
        // lblLang
        // 
        resources.ApplyResources(lblLang, "lblLang");
        lblLang.Name <- "lblLang";
        // 
        // btnBrowse
        // 
        resources.ApplyResources(btnBrowse, "btnBrowse");
        btnBrowse.Name <- "btnBrowse";
        btnBrowse.UseVisualStyleBackColor <- true;
        btnBrowse.Click.AddHandler(fun s e -> this.Browse());
        //this.btnBrowse.Click += new System.EventHandler(this.btnBrowse_Click);
        // 
        // btnFind
        // 
        resources.ApplyResources(btnFind, "btnFind");
        btnFind.Name <- "btnFind";
        btnFind.UseVisualStyleBackColor <- true;
        btnFind.Click.AddHandler(fun s e -> this.Search());  
        // 
        // txtQuery
        // 
        resources.ApplyResources(txtQuery, "txtQuery");
        txtQuery.Name <- "txtQuery";
        // 
        // btnSelect
        // 
        resources.ApplyResources(btnSelect, "btnSelect");
        btnSelect.Name <- "btnSelect";
        btnSelect.UseVisualStyleBackColor <- true;
        btnSelect.Click.AddHandler(fun s e -> if (this.SelectFolder()) then this.ClearAllViewObjs(true));
        //this.btnSelect.Click += new System.EventHandler(this.btnSelect_Click);
        // 
        // txtFolder
        // 
        resources.ApplyResources(txtFolder, "txtFolder");
        txtFolder.Name <- "txtFolder";
        // 
        // lblFolder
        // 
        resources.ApplyResources(lblFolder, "lblFolder");
        lblFolder.Name <- "lblFolder";
        // 
        // txtUrl
        // 
        resources.ApplyResources(txtUrl, "txtUrl");
        txtUrl.Name <- "txtUrl";
        // 
        // lblUrl
        // 
        resources.ApplyResources(lblUrl, "lblUrl");
        lblUrl.Name <- "lblUrl";
        (* // 
        // txtLimitChildItems
        // 
        resources.ApplyResources(txtLimitChildItems, "txtLimitChildItems");
        txtLimitChildItems.Name <- "txtLimitChildItems";
        // 
        // lblLimitChildItems
        // 
        resources.ApplyResources(lblLimitChildItems, "lblLimitChildItems");
        lblLimitChildItems.Name <- "lblLimitChildItems"; *)
        // 
        // txtDepthTocLevel
        // 
        resources.ApplyResources(txtDepthTocLevel, "txtDepthTocLevel");
        txtDepthTocLevel.Name <- "txtDepthTocLevel";
        // 
        // lblDepthTocLevel
        // 
        resources.ApplyResources(lblDepthTocLevel, "lblDepthTocLevel");
        lblDepthTocLevel.Name <- "lblDepthTocLevel";
        // 
        // chkAutoReplaceUrls
        // 
        resources.ApplyResources(chkAutoReplaceUrls, "chkAutoReplaceUrls");
        chkAutoReplaceUrls.Checked <- true;
        chkAutoReplaceUrls.CheckState <- System.Windows.Forms.CheckState.Checked;
        chkAutoReplaceUrls.Name <- "chkAutoReplaceUrls";
        chkAutoReplaceUrls.UseVisualStyleBackColor <- true;
        // 
        // folderBrowserDialog
        // 
        resources.ApplyResources(folderBrowserDialog, "folderBrowserDialog");
        folderBrowserDialog.RootFolder <- System.Environment.SpecialFolder.CommonDocuments;
        // 
        // menuStrip
        // 
        ignore(menuStrip.Items.Add(fileToolStripMenuItem));
        ignore(menuStrip.Items.Add(windowToolStripMenuItem));
        resources.ApplyResources(menuStrip, "menuStrip");
        menuStrip.Name <- "menuStrip";
        // 
        // fileToolStripMenuItem
        // 
        fileToolStripMenuItem.Name <- "fileToolStripMenuItem";
        resources.ApplyResources(fileToolStripMenuItem, "fileToolStripMenuItem");
        // 
        // openToolStripMenuItem
        // 
        ignore(fileToolStripMenuItem.DropDownItems.Add(openToolStripMenuItem));
        openToolStripMenuItem.Name <- "openToolStripMenuItem";
        resources.ApplyResources(openToolStripMenuItem, "openToolStripMenuItem");
        openToolStripMenuItem.Click.AddHandler(fun s e -> if (this.SelectFolder()) then this.Browse()); 
        // 
        // toolStripSeparator2
        // 
        ignore(fileToolStripMenuItem.DropDownItems.Add(toolStripSeparator2));
        toolStripSeparator2.Name <- "toolStripSeparator2";
        resources.ApplyResources(toolStripSeparator2, "toolStripSeparator2");
        toolStripSeparator2.Click.AddHandler(fun s e -> this.Close()); 
        // 
        // downloadAllToolStripMenuItem
        // 
        ignore(fileToolStripMenuItem.DropDownItems.Add(downloadAllToolStripMenuItem));
        downloadAllToolStripMenuItem.Name <- "downloadAllToolStripMenuItem";
        resources.ApplyResources(downloadAllToolStripMenuItem, "downloadAllToolStripMenuItem");
        downloadAllToolStripMenuItem.Click.AddHandler(fun s e -> this.DownloadAll()); 
        // 
        // relplaceAllLinksToolStripMenuItem
        // 
        ignore(fileToolStripMenuItem.DropDownItems.Add(relplaceAllLinksToolStripMenuItem));
        relplaceAllLinksToolStripMenuItem.Name <- "relplaceAllLinksToolStripMenuItem";
        resources.ApplyResources(relplaceAllLinksToolStripMenuItem, "relplaceAllLinksToolStripMenuItem");
        relplaceAllLinksToolStripMenuItem.Click.AddHandler(fun s e -> this.ReplaceAllLinks()); 
        // 
        // refreshTOCToolStripMenuItem
        // 
        ignore(fileToolStripMenuItem.DropDownItems.Add(refreshTOCToolStripMenuItem));
        refreshTOCToolStripMenuItem.Name <- "refreshTOCToolStripMenuItem";
        resources.ApplyResources(refreshTOCToolStripMenuItem, "refreshTOCToolStripMenuItem");
        refreshTOCToolStripMenuItem.Click.AddHandler(fun s e -> this.LoadTOCAll()); 
        // 
        // updateNodeToolStripMenuItem
        // 
        ignore(fileToolStripMenuItem.DropDownItems.Add(updateNodeToolStripMenuItem));
        updateNodeToolStripMenuItem.Name <- "updateNodeToolStripMenuItem";
        resources.ApplyResources(updateNodeToolStripMenuItem, "updateNodeToolStripMenuItem");
        updateNodeToolStripMenuItem.Click.AddHandler(fun s e -> this.UpdateNode()); 
        // 
        // terminateOperationToolStripMenuItem
        // 
        ignore(fileToolStripMenuItem.DropDownItems.Add(terminateOperationToolStripMenuItem));
        terminateOperationToolStripMenuItem.Name <- "terminateOperationToolStripMenuItem";
        resources.ApplyResources(terminateOperationToolStripMenuItem, "terminateOperationToolStripMenuItem");
        terminateOperationToolStripMenuItem.Click.AddHandler(fun s e -> this.TerminateOperation()); 
        // 
        // toolStripSeparator1
        // 
        ignore(fileToolStripMenuItem.DropDownItems.Add(toolStripSeparator1));
        toolStripSeparator1.Name <- "toolStripSeparator1";
        resources.ApplyResources(toolStripSeparator1, "toolStripSeparator1");
        toolStripSeparator1.Click.AddHandler(fun s e -> this.Close()); 
        // 
        // exitToolStripMenuItem
        // 
        ignore(fileToolStripMenuItem.DropDownItems.Add(exitToolStripMenuItem));
        exitToolStripMenuItem.Name <- "exitToolStripMenuItem";
        resources.ApplyResources(exitToolStripMenuItem, "exitToolStripMenuItem");
        exitToolStripMenuItem.Click.AddHandler(fun s e -> this.Close()); 
        //this.exitToolStripMenuItem.Click += new System.EventHandler(this.exitToolStripMenuItem_Click);
        // 
        // windowToolStripMenuItem
        // 
        ignore(windowToolStripMenuItem.DropDownItems.Add(aboutToolStripMenuItem));
        windowToolStripMenuItem.Name <- "windowToolStripMenuItem";
        resources.ApplyResources(windowToolStripMenuItem, "windowToolStripMenuItem");
        // 
        // aboutToolStripMenuItem
        // 
        aboutToolStripMenuItem.Name <- "aboutToolStripMenuItem";
        resources.ApplyResources(aboutToolStripMenuItem, "aboutToolStripMenuItem");
        aboutToolStripMenuItem.Click.AddHandler(fun s e ->
            let aboutBox = new AboutBox.AboutBox();
            ignore(aboutBox.ShowDialog(this));); 
        //this.aboutToolStripMenuItem.Click += new System.EventHandler(this.aboutToolStripMenuItem_Click);
        // 
        // statusStrip
        //
        ignore(statusStrip.Items.Add(toolStripStatusLabel));  
        ignore(statusStrip.Items.Add(toolStripProgressBar));  
        resources.ApplyResources(statusStrip, "statusStrip");
        statusStrip.Name <- "statusStrip";
        // 
        // toolStripStatusLabel
        // 
        toolStripStatusLabel.Name <- "toolStripStatusLabel";
        resources.ApplyResources(toolStripStatusLabel, "toolStripStatusLabel");
        toolStripStatusLabel.Spring <- true;
        // 
        // toolStripProgressBar
        // 
        toolStripProgressBar.Name <- "toolStripProgressBar";
        resources.ApplyResources(toolStripProgressBar, "toolStripProgressBar");
        toolStripProgressBar.Visible <- false;
        //
        // frmTimer.Tick event
        //
        frmTimer.Tick.AddHandler(fun s e ->
            if (this.statusStripValues.OperationCompleted 
                    || cancelltionSource = null) then
                frmTimer.Stop() 
                if (this.statusStripValues.ListErrors.Length > 0) then
                    this.ShowListErrors(this.statusStripValues.ListErrors) 
                if (cancelltionSource <> null) then
                    cancelltionSource.Dispose()
                    cancelltionSource <- null 
                if (not <| downloadAllToolStripMenuItem.Enabled) then 
                    downloadAllToolStripMenuItem.Enabled <- true
                if (terminateOperationToolStripMenuItem.Enabled) then 
                    terminateOperationToolStripMenuItem.Enabled <- false
                if (not <| refreshTOCToolStripMenuItem.Enabled) then
                    refreshTOCToolStripMenuItem.Enabled <- true
                if (not <| updateNodeToolStripMenuItem.Enabled) then
                    updateNodeToolStripMenuItem.Enabled <- true 
                if (not <| relplaceAllLinksToolStripMenuItem.Enabled) then
                    relplaceAllLinksToolStripMenuItem.Enabled <- true
                if (not <| btnBrowse.Enabled) then
                    btnBrowse.Enabled <- true 
                if (not <| this.statusStripValues.OperationTerminated) then
                    let runningOperation = this.runningOperation
                    match runningOperation with
                        | DownloadAll -> if Directory.GetFiles(currentFolder, "*.xml").Length > lastXmlFiles then this.LoadTOCAll()
                        | AddChildNodes -> ()
                        | BrowseAll -> webBrowser.Navigate(Path.Combine(currentFolder, GetLocalFileForUrl(currentUrl))); tabControl.SelectedTab <- tabPgBrowse
                        | ReplaceAll -> ()
                        | None -> ()
                    this.statusStripValues.Reset()
                    currentFolder <- String.Empty  
                    currentUrl <- String.Empty 
                    currentLang <- String.Empty
                    let nextOperation = this.nextOperation
                    match nextOperation with 
                        | DownloadAll -> ()
                        | AddChildNodes -> ()
                        | BrowseAll -> ()
                        | ReplaceAll -> () 
                        | None -> ()
                else
                    let nextOperation = this.nextOperation
                    this.statusStripValues.Reset()
                    match nextOperation with 
                        | DownloadAll -> ()
                        | AddChildNodes -> ()
                        | BrowseAll -> this.Browse()
                        | ReplaceAll -> ()
                        | None -> ()
            try
                let procTxt = if (this.statusStripValues.ProgressBarValue > 0) then "[" + this.statusStripValues.CurCount.ToString() + "/" + this.statusStripValues.MaxCount.ToString() + " (" + (((float)this.statusStripValues.CurCount * 100.0) / (float)this.statusStripValues.MaxCount).ToString("F") + "%)] " else String.Empty
                let waitTxt = if (this.statusStripValues.OperationTerminated) then " [" + ModuleResoures.GetAppResourceString("StatusWaitCompletion") + "] " else String.Empty   
                let lblTxt = procTxt + waitTxt + this.statusStripValues.StatusLabelValue
                if (toolStripStatusLabel.Text.CompareTo(lblTxt) <> 0) then
                    toolStripStatusLabel.Text <- lblTxt
                if (toolStripProgressBar.Value <> this.statusStripValues.ProgressBarValue) then
                    toolStripProgressBar.Value <- this.statusStripValues.ProgressBarValue
                    if (this.statusStripValues.ProgressBarValue > 0) then
                        if (not <| toolStripProgressBar.Visible) then
                            toolStripProgressBar.Visible <- true 
                    else
                        if (toolStripProgressBar.Visible) then
                            toolStripProgressBar.Visible <- false
            with
                _ -> ()                 
            );
        //
        // Closing event
        //
        this.Closing.AddHandler(fun s e ->
            if (not(System.String.IsNullOrEmpty(txtFolder.Text)) 
                && this.additionalLinks <> null
                && not(this.additionalLinks.IsEmpty)) then
                    this.additionalLinks.Save(Path.Combine(txtFolder.Text, CommonDefs.FileAdditionalLinks)));  
        // 
        // MainForm
        //
        resources.ApplyResources(this, "$this");
        this.AutoScaleMode <- System.Windows.Forms.AutoScaleMode.Font;
        this.Controls.Add(statusStrip);
        this.Controls.Add(tabControl);
        this.Controls.Add(menuStrip);
        this.MainMenuStrip <- menuStrip;
        this.Name <- "MainForm";
        splitContainer.Panel1.ResumeLayout(false);
        splitContainer.Panel2.ResumeLayout(false);
        (splitContainer :> System.ComponentModel.ISupportInitialize).EndInit();
        //((System.ComponentModel.ISupportInitialize)(splitContainer)).EndInit();
        splitContainer.ResumeLayout(false);
        tabControl.ResumeLayout(false);
        tabPgBrowse.ResumeLayout(false);
        menuStrip.ResumeLayout(false);
        menuStrip.PerformLayout();
        statusStrip.ResumeLayout(false);
        statusStrip.PerformLayout();
        this.ResumeLayout(false);
        this.PerformLayout()
        
    member public this.ClearAllViewObjs(showMessage: bool) =
        if (treeView.Nodes.Count > 0) then
            treeView.Nodes.Clear()  
        let document = webBrowser.Document
        if (document <> null) then
            webBrowser.DocumentText <- String.Empty
            if (showMessage) then
                webBrowser.Document.Write("<HTML><BODY><CENTER>" 
                    + Resoures.ModuleResoures.GetAppResourceString("NoAnyLoadedDoc") 
                    + "</CENTER></BODY></HTML>")  
            webBrowser.Refresh()
        Application.DoEvents()  

    member public this.ClearBrowser() =
        let document = webBrowser.Document
        if (document <> null) then
            webBrowser.DocumentText <- String.Empty
            webBrowser.Document.Write("<HTML><BODY><CENTER>" 
                + Resoures.ModuleResoures.GetAppResourceString("NoAnyLoadedDoc") 
                + "</CENTER></BODY></HTML>")  
            webBrowser.Refresh()  

    member public this.ShowListErrors(lstErr: (string*string) list) =
        if (lstErr.Length > 0) then
            Application.UseWaitCursor <- false
            if (lstErr.Length > 1) then
                let errorsForm = new ErrorsForm(lstErr)
                ignore(errorsForm.ShowDialog(this))
            else
                let (obj, err) = lstErr.Item(0)  
                ignore(MessageBox.Show(
                        this, 
                        obj + " -> " + err, 
                        Resoures.ModuleResoures.GetAppResourceString("CaptionError"), 
                        MessageBoxButtons.OK, 
                        MessageBoxIcon.Error)) 


    member public this.getObjFromFileSiteInfo(fileSiteInfo: string): SiteInfo =
        let mutable retVal: SiteInfo = new SiteInfo("", "")
        try
            if (fileSiteInfo = null || fileSiteInfo.Length = 0) then
               raise <| new ArgumentNullException("fileSiteInfo")
            if (not <| System.IO.File.Exists(fileSiteInfo)) then
               raise <| new System.IO.FileNotFoundException(fileSiteInfo)
            let ser: DataContractSerializer = new DataContractSerializer(typeof<SiteInfo>)
            if (ser = null) then
               raise <| new NullReferenceException("ser " 
                                + Resoures.ModuleResoures.GetAppResourceString("PhraseAs") 
                                + " DataContractSerializer")
            use reader: FileStream = new FileStream(fileSiteInfo, FileMode.Open)
            if (reader = null) then
               raise <| new NullReferenceException("FileStream(" + fileSiteInfo + ")")
            retVal <- ser.ReadObject(reader) :?> SiteInfo
            if (retVal.Equals(null) || retVal.url = null || retVal.url.Length = 0) then
                raise <| new ArgumentNullException("siteInfo.url")
        with
            | _ as ex -> ignore(
                            System.Windows.Forms.MessageBox.Show(
                                this, 
                                ex.ToString(), 
                                Resoures.ModuleResoures.GetAppResourceString("CaptionError"), 
                                System.Windows.Forms.MessageBoxButtons.OK, 
                                System.Windows.Forms.MessageBoxIcon.Error))       
        retVal

    member public this.SaveAsFileSiteInfo(url: string, lang: string, fileSiteInfo: string): bool =
        let mutable retVal: bool = false;
        try
            if (url = null || url.Length = 0) then
               raise <| new ArgumentNullException("url")
            if (lang = null || lang.Length = 0) then
               raise <| new ArgumentNullException("lang")
            if (fileSiteInfo = null || fileSiteInfo.Length = 0) then
               raise <| new ArgumentNullException("fileSiteInfo")
            if (File.Exists(fileSiteInfo)) then
                File.Delete(fileSiteInfo)  
            let siteInfo: SiteInfo = new SiteInfo(url, lang);
            if (siteInfo.Equals(null) || siteInfo.url = null || siteInfo.url.Length = 0 || siteInfo.lang = null || siteInfo.lang.Length = 0) then
               raise <| new NullReferenceException("siteInfo")
            let ser: DataContractSerializer = new DataContractSerializer(typeof<SiteInfo>) //XmlSerializer(typeof<SiteInfo>);
            if (ser = null) then
               raise <| new NullReferenceException("ser " 
                                + Resoures.ModuleResoures.GetAppResourceString("PhraseAs") 
                                + " DataContractSerializer")
            use writer: FileStream = new FileStream(fileSiteInfo, FileMode.Create)
            if (writer = null) then
               raise <| new NullReferenceException("FileStream(" + fileSiteInfo + ")")
            ser.WriteObject(writer, siteInfo)
            retVal <- true 
        with
            | _ as ex -> ignore(
                            System.Windows.Forms.MessageBox.Show(
                                this, 
                                ex.ToString(), 
                                Resoures.ModuleResoures.GetAppResourceString("CaptionError"), 
                                System.Windows.Forms.MessageBoxButtons.OK, 
                                System.Windows.Forms.MessageBoxIcon.Error))       
        retVal

    member public this.SelectFolder(): bool =
        if (folderBrowserDialog.ShowDialog(this) = System.Windows.Forms.DialogResult.OK) then
            if (not <| System.String.IsNullOrEmpty(txtFolder.Text) 
                    && not <| (txtFolder.Text = folderBrowserDialog.SelectedPath)
                    && this.additionalLinks <> null
                    && not(this.additionalLinks.IsEmpty)) then
                this.additionalLinks.Save(Path.Combine(txtFolder.Text, CommonDefs.FileAdditionalLinks))
                this.additionalLinks <- XElement(xname "root")                
            txtFolder.Text <- folderBrowserDialog.SelectedPath;
            let fileSiteInfo = Path.Combine(folderBrowserDialog.SelectedPath, CommonDefs.FileSiteInfo) 
            if (Directory.Exists(folderBrowserDialog.SelectedPath)) then
                if (File.Exists(fileSiteInfo)) then
                    let siteInfo = this.getObjFromFileSiteInfo(fileSiteInfo)
                    if (not <| siteInfo.Equals(null)) then
                        if (siteInfo.url <> null) then
                            txtUrl.Text <- siteInfo.url
                        if (siteInfo.lang <> null) then 
                            cobLang.SelectedItem <- siteInfo.lang
                        (*let xmlFileAdditionalLinks = Path.Combine(txtFolder.Text, CommonDefs.FileAdditionalLinks) 
                        if (File.Exists(xmlFileAdditionalLinks)) then    
                            this.additionalLinks <- XElement.Load(xmlFileAdditionalLinks) *)
                else 
                    if (not <| String.IsNullOrEmpty(txtUrl.Text)) then
                        ignore(this.SaveAsFileSiteInfo(txtUrl.Text, cobLang.SelectedItem :?> string, fileSiteInfo)) 
                        (*let xmlFileAdditionalLinks = Path.Combine(txtFolder.Text, CommonDefs.FileAdditionalLinks) 
                        if (File.Exists(xmlFileAdditionalLinks)) then    
                            this.additionalLinks <- XElement.Load(xmlFileAdditionalLinks) *)
            downloadAllToolStripMenuItem.Enabled <- true
            relplaceAllLinksToolStripMenuItem.Enabled <- true 
            true
        else
            false
    
    member public this.TerminateOperation() =
        if (cancelltionSource <> null) then
            this.statusStripValues.OperationTerminated <- true
            toolStripStatusLabel.Text <- ModuleResoures.GetAppResourceString("StatusTerminated")
            terminateOperationToolStripMenuItem.Enabled <- false  
            cancelltionSource.Cancel()
            //ignore(Async.TryCancelled(this.currentAction, fun (oe) -> this.statusStripValues.OperationCompleted <- true))

    member public this.Browse() =
        if (not <| String.IsNullOrEmpty(txtFolder.Text) && not <| String.IsNullOrEmpty(txtUrl.Text) ) then
            let fileSiteInfo = Path.Combine(txtFolder.Text, CommonDefs.FileSiteInfo)
            if (not <| Directory.Exists(txtFolder.Text)) then
                ignore(Directory.CreateDirectory(txtFolder.Text)) 
            if (Directory.Exists(txtFolder.Text)) then
                if (File.Exists(fileSiteInfo)) then
                    let siteInfo = this.getObjFromFileSiteInfo(fileSiteInfo)
                    if (siteInfo.url.CompareTo(txtUrl.Text) <> 0 
                            || siteInfo.lang.CompareTo(cobLang.SelectedItem :?> string) <> 0) then
                        File.Delete(fileSiteInfo)
                        ignore(this.SaveAsFileSiteInfo(txtUrl.Text, cobLang.SelectedItem :?> string, fileSiteInfo))
                else 
                    ignore(this.SaveAsFileSiteInfo(txtUrl.Text, cobLang.SelectedItem :?> string, fileSiteInfo)) 
                if (cancelltionSource <> null) then
                    this.nextOperation <- Operation.BrowseAll
                    this.TerminateOperation()
                else 
                    if (not <| frmTimer.Enabled) then
                        this.ClearAllViewObjs(false)
                        this.statusStripValues.Reset() 
                        frmTimer.Start() 
                        this.runningOperation <- Operation.BrowseAll
                        this.nextOperation <- Operation.None
                        refreshTOCToolStripMenuItem.Enabled <- false
                        downloadAllToolStripMenuItem.Enabled <- false
                        relplaceAllLinksToolStripMenuItem.Enabled <- false
                        updateNodeToolStripMenuItem.Enabled <- false
                        terminateOperationToolStripMenuItem.Enabled <- true
                        btnBrowse.Enabled <- false 
                        cancelltionSource <- new System.Threading.CancellationTokenSource()
                        currentFolder <- txtFolder.Text
                        currentUrl <- txtUrl.Text
                        currentLang <- cobLang.SelectedItem :?> string
                        let xmlFileAdditionalLinks = Path.Combine(txtFolder.Text, CommonDefs.FileAdditionalLinks) 
                        if (File.Exists(xmlFileAdditionalLinks)) then    
                            this.additionalLinks <- XElement.Load(xmlFileAdditionalLinks) 
                        hsFilesInFolder.Clear()
                        hsFilesInSubfolder.Clear()
                        if (CommonDefs.UseCheckFilesSizeProblem) then
                            let htmlFiles = Directory.GetFiles(currentFolder, "*" + CommonDefs.HtmlExt)
                            if (htmlFiles.Length > CommonDefs.MaxFilesSizeProblem) then
                                if (chkAutoReplaceUrls.Checked) then
                                  chkAutoReplaceUrls.Checked <- false
                                if (String.IsNullOrEmpty(txtDepthTocLevel.Text)) then
                                    txtDepthTocLevel.Text <- System.Convert.ToString(CommonDefs.MaxDepthTocLevel)
                            else
                                if (not(chkAutoReplaceUrls.Checked)) then
                                  chkAutoReplaceUrls.Checked <- true
                                if (not(String.IsNullOrEmpty(txtDepthTocLevel.Text))) then
                                    txtDepthTocLevel.Text <- String.Empty 
                        BrowseAll(this.statusStripValues, 
                            cancelltionSource, 
                            treeView,
                            this.additionalLinks, 
                            currentFolder, 
                            (if (String.IsNullOrEmpty(txtDepthTocLevel.Text)) then 0 else System.Int32.Parse(txtDepthTocLevel.Text)), 
                            0(*(if (String.IsNullOrEmpty(txtLimitChildItems.Text)) then 0 else System.Int32.Parse(txtLimitChildItems.Text))*), 
                            currentUrl, 
                            currentLang,
                            chkAutoReplaceUrls.Checked,
                            hsFilesInFolder,
                            hsFilesInSubfolder)
                             
    member public this.DownloadAll() =
        if (not <| String.IsNullOrEmpty(txtFolder.Text) && not <| String.IsNullOrEmpty(txtUrl.Text)) then
            if (cancelltionSource <> null) then
                this.nextOperation <- Operation.None
                this.TerminateOperation()
            else 
                if (not <| frmTimer.Enabled) then
                    this.statusStripValues.Reset()
                    frmTimer.Start() 
                    terminateOperationToolStripMenuItem.Enabled <- true
                    downloadAllToolStripMenuItem.Enabled <- false
                    refreshTOCToolStripMenuItem.Enabled <- false
                    relplaceAllLinksToolStripMenuItem.Enabled <- false
                    updateNodeToolStripMenuItem.Enabled <- false
                    btnBrowse.Enabled <- false 
                    this.runningOperation <- Operation.DownloadAll
                    this.nextOperation <- Operation.None 
                    cancelltionSource <- new System.Threading.CancellationTokenSource()  
                    currentFolder <- txtFolder.Text
                    currentUrl <- txtUrl.Text
                    currentLang <- cobLang.SelectedItem :?> string
                    this.statusStripValues.StatusLabelValue <- ModuleResoures.GetAppResourceString("StatusSearchData") + " - " + currentFolder
                    toolStripStatusLabel.Text <- this.statusStripValues.StatusLabelValue
                    Application.DoEvents() 
                    lastXmlFiles <- Directory.GetFiles(currentFolder, "*" + CommonDefs.XmlExt).Length
                    DownloadAll(this.statusStripValues, 
                        cancelltionSource, 
                        this.additionalLinks,
                        currentFolder, 
                        currentUrl, 
                        currentLang,
                        chkAutoReplaceUrls.Checked,
                        hsFilesInFolder,
                        hsFilesInSubfolder)
    
    member public this.LoadTOCAll() =
        if (not <| String.IsNullOrEmpty(txtFolder.Text) && not <| String.IsNullOrEmpty(txtUrl.Text)) then
            if (cancelltionSource <> null) then
                this.nextOperation <- Operation.None
                this.TerminateOperation()
            else 
                if (not <| frmTimer.Enabled) then
                    this.statusStripValues.Reset()
                    frmTimer.Start() 
                    terminateOperationToolStripMenuItem.Enabled <- true
                    downloadAllToolStripMenuItem.Enabled <- false
                    refreshTOCToolStripMenuItem.Enabled <- false
                    relplaceAllLinksToolStripMenuItem.Enabled <- false
                    updateNodeToolStripMenuItem.Enabled <- false
                    btnBrowse.Enabled <- false 
                    this.runningOperation <- Operation.AddChildNodes
                    this.nextOperation <- Operation.ReplaceAll 
                    cancelltionSource <- new System.Threading.CancellationTokenSource()  
                    currentFolder <- txtFolder.Text
                    currentUrl <- txtUrl.Text
                    currentLang <- cobLang.SelectedItem :?> string
                    LoadTOC(this.statusStripValues, 
                        cancelltionSource, 
                        treeView,
                        this.additionalLinks,                        
                        currentFolder, 
                        0, 
                        0, 
                        currentUrl, 
                        currentLang,
                        chkAutoReplaceUrls.Checked,
                        hsFilesInFolder,
                        hsFilesInSubfolder)

    member public this.ReplaceAllLinks() =
        if (not <| String.IsNullOrEmpty(txtFolder.Text) && not <| String.IsNullOrEmpty(txtUrl.Text)) then
            if (cancelltionSource <> null) then
                this.nextOperation <- Operation.None
                this.TerminateOperation()
            else 
                if (not <| frmTimer.Enabled) then
                    this.statusStripValues.Reset()
                    frmTimer.Start() 
                    terminateOperationToolStripMenuItem.Enabled <- true
                    downloadAllToolStripMenuItem.Enabled <- false
                    refreshTOCToolStripMenuItem.Enabled <- false
                    relplaceAllLinksToolStripMenuItem.Enabled <- false
                    updateNodeToolStripMenuItem.Enabled <- false
                    btnBrowse.Enabled <- false 
                    this.runningOperation <- Operation.ReplaceAll 
                    this.nextOperation <- Operation.None 
                    cancelltionSource <- new System.Threading.CancellationTokenSource()  
                    currentFolder <- txtFolder.Text
                    currentUrl <- txtUrl.Text
                    currentLang <- cobLang.SelectedItem :?> string
                    ReplaceAll(this.statusStripValues, 
                        cancelltionSource,
                        this.additionalLinks, 
                        currentFolder, 
                        currentUrl,
                        hsFilesInFolder)
    member public this.UpdateNode() =
        if (not <| String.IsNullOrEmpty(txtFolder.Text) && not <| String.IsNullOrEmpty(txtUrl.Text)) then
            if (cancelltionSource = null) then
                if (treeView.Nodes.Count > 0 && treeView.SelectedNode <> null) then 
                    let mutable curUrl = treeView.SelectedNode.Tag :?> string
                    let fileName = Path.GetFileNameWithoutExtension(curUrl)
                    if (fileName.Contains(".") && not(this.additionalLinks.IsEmpty)) then 
                        let canonicalHref = this.additionalLinks.XPathSelectElement("link/hrefCanonical[.='" + curUrl + "']")
                        if (canonicalHref <> null) then
                            curUrl <- canonicalHref.Parent.Element(xname "hrefNormalized").Value
                    let localFile = GetLocalFile(txtFolder.Text, curUrl, CommonDefs.HtmlExt)
                    if (File.Exists(localFile)) then
                        File.Delete(localFile) 
                    let (lfHtm, lstErr) = GetDataToView(
                                            this.additionalLinks, 
                                            txtFolder.Text, 
                                            curUrl, 
                                            cobLang.SelectedItem :?> string, 
                                            chkAutoReplaceUrls.Checked, 
                                            hsFilesInFolder,
                                            hsFilesInSubfolder)
                    webBrowser.Navigate(lfHtm)
                    this.ShowListErrors(lstErr) 
    member public this.Search() =
        if (not <| String.IsNullOrEmpty(txtQuery.Text) && not <| String.IsNullOrEmpty(txtFolder.Text)) then 
            try
                Application.UseWaitCursor <- true
                Application.DoEvents()
                let lstSearchResult = SearchUserQuery(txtFolder.Text, CommonDefs.HtmlExt, CommonDefs.QuerySelectColumns, txtQuery.Text)
                let html = GenHtmlForQueryResult(txtFolder.Text, txtQuery.Text, lstSearchResult)
                let fileResult = Path.Combine(txtFolder.Text, CommonDefs.FileSearch)
                if (File.Exists(fileResult)) then
                    File.Delete(fileResult) 
                SaveAsFile(fileResult, html)
                webBrowser.Navigate(fileResult)
                Application.UseWaitCursor <- false
            with
            | _ as ex -> ignore(
                            Application.UseWaitCursor <- false
                            System.Windows.Forms.MessageBox.Show(
                                this, 
                                ex.ToString(), 
                                Resoures.ModuleResoures.GetAppResourceString("CaptionError"), 
                                System.Windows.Forms.MessageBoxButtons.OK, 
                                System.Windows.Forms.MessageBoxIcon.Error))       
